import unittest
import manage_sys_paths
import json

from messaging.MessageHandler import MessageHandler
from messaging.DummyMessageManager import DummyMessageManager as DummyMessageSender
    
class DummyMongoRepo:
    '''Dummy class to be used for testing the MessageHandler'''
    last_trace = None
    DBnodes = []
    def insert_trace(self, trace):
        self.last_trace = trace

    def get_layers_for_use_case_and_table(use_case, table):

        testLayers = [
            {
                "layer_name": "layer1",
                "properties": [
                                "UniqueID",
                                "doughType"                                
                                ],
                "table": "pizza",
                "total_properties": [
                                "UniqueID",
                                "doughType",
                                "firstTopping",
                                "firstToppingPrice",
                                "hasSpinach",
                                "name",
                                "toppingInfo"
                                ],
                "use_case": "debug"
            },
            {
                "layer_name": "layer2",
                "properties": [
                                "firstTopping"                            
                                ],
                "table": "pizza",
                "total_properties": [
                                "UniqueID",
                                "doughType",
                                "firstTopping",
                                "firstToppingPrice",
                                "hasSpinach",
                                "name",
                                "toppingInfo"
                                ],
                "use_case": "debug"
            }
        ]
        returnLayers = []
        for layer in testLayers:
            if (layer["use_case"] == use_case) and (layer["table"] == table):
                returnLayers.append(layer)

        return returnLayers

    # layers = self._repository.get_layers_for_use_case_and_table(use_case, table)

    ## if no local layers are found, fetch information from server
    # if len(layers) == 0:
    # layers = self._fetch_layer_information(use_case, table)

    # self._repository.delete_layer(layer)
    # self._repository.add_layer(layer)
    #TODO
    # nodes_in_db = self._repository.get_nodes_from_ids(unique_id_list)
    
    
    #TODO first
    # self._repository.add_layer_nodes(nodes)
    def add_layer_nodessss(nodes):
        DBnodes.extend(nodes)
        return
        


class Test_Pipeline(unittest.TestCase):
    handler = None
    repo = None
    msg_sender = None

    def setUp(self):
        self.repo = DummyMongoRepo()
        self.msg_sender = DummyMessageSender.get_instance()
        self.handler = MessageHandler()
    
    def _buildTraceMessage(self):
        return {
            "type": "new-trace", 
            "content": {
                "use_case": "debug", 
                "table": "pizza", 
                "id": "9e1e0983ada4e79de324a80b5f35f681c3e5016b08e1d6612c17892ade17e2c0", 
                'properties': {
                    "UniqueID": "9e1e0983ada4e79de324a80b5f35f681c3e5016b08e1d6612c17892ade17e2c0",
                    "doughType": "wheat",
                    "firstTopping": "Tomato Sauce",
                    "firstToppingPrice": 1.00,
                    "hasSpinach": False,
                    "name": "Diavolo",
                    "toppingInfo": "Tomato Sauce1.00",
                }
            }
        }

    def testTraceProcessing(self):
        msg = self._buildTraceMessage()
        self.handler.handle_new_trace(msg["content"])
    
    def testDuplicateTrace(self):
        msg = self._buildTraceMessage()
        msg2 = self._buildTraceMessage()
        self.handler.handle_new_trace(msg["content"])
        self.handler.handle_new_trace(msg2["content"])

        self.assertEqual(len(self.repo.DBnodes),1)

if __name__ == '__main__':
    unittest.main()